/* eslint-disable */
/**
 * This file was automatically generated by json-schema-to-typescript.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run json-schema-to-typescript to regenerate this file.
 */

/**
 * This schema describes the structure of the main configuration file 'dzg.config.json'. It is used to validate the configuration file and to document the available settings.
 */
export interface MainConfigurationFileSchema {
  /**
   * General, sitewide settings.
   */
  general: {
    /**
     * Short name of the institution.
     */
    name_short: string;
    /**
     * Long name of the institution.
     */
    name_long: string;
    [k: string]: unknown;
  };
  /**
   * Data processing related settings.
   */
  data: {
    parse_fields: {
      /**
       * Path to the field to be parsed.
       */
      from_path: string;
      /**
       * Path to the field to be created.
       */
      to_path: string;
      /**
       * Type of the parser to use. Currently only 'date' is supported.
       */
      type: "date";
      [k: string]: unknown;
    }[];
    [k: string]: unknown;
  };
  /**
   * Settings for the study list view.
   */
  list: {
    /**
     * Default sort order for the study list.
     */
    sort: {
      /**
       * Sort by field. Key must be a valid path. Value must be -1 for descending or 1 for ascending order.
       *
       * This interface was referenced by `undefined`'s JSON-Schema definition
       * via the `patternProperty` "^.*$".
       */
      [k: string]: -1 | 1;
    }[];
    /**
     * List of filters to be displayed.
     */
    filters: (
      | {
          /**
           * Label of the filter.
           */
          label: string;
          /**
           * Type of the filter.
           */
          type: "text";
          /**
           * Threshold for the match sorter. See https://github.com/kentcdodds/match-sorter?tab=readme-ov-file#threshold-number
           */
          threshold?:
            | "CASE_SENSITIVE_EQUAL"
            | "EQUAL"
            | "STARTS_WITH"
            | "WORD_STARTS_WITH"
            | "CONTAINS"
            | "ACRONYM"
            | "MATCHES"
            | "NO_MATCH";
          /**
           * Placeholder text for the filter input.
           */
          placeholder: string;
          /**
           * List of paths to the fields to be filtered.
           */
          paths: string[];
        }
      | {
          /**
           * Label of the filter.
           */
          label: string;
          /**
           * Type of the filter.
           */
          type: "enum";
          /**
           * Path to the field to be filtered.
           */
          path: string;
          /**
           * Name of the component to be used to render the filter options.
           */
          component?: string;
        }
      | {
          /**
           * Label of the filter.
           */
          label: string;
          /**
           * Type of the filter.
           */
          type: "enum_multiple";
          /**
           * Path to the field to be filtered. Should be an array.
           */
          path: string;
          /**
           * Name of the component to be used to render the filter options.
           */
          component?: string;
        }
      | {
          /**
           * Label of the filter.
           */
          label: string;
          /**
           * Type of the filter.
           */
          type: "date_range";
          /**
           * Path to the field to be filtered.
           */
          path: string;
        }
      | {
          /**
           * Label of the filter.
           */
          label: string;
          /**
           * Type of the filter.
           */
          type: "multi_enum";
          /**
           * List of the fields to be filtered. Can be a mix of arrays and single values.
           */
          fields: {
            /**
             * Label of the filter.
             */
            label: string;
            /**
             * Path to the field to be filtered.
             */
            path: string;
            /**
             * Dependent fields to show conditionally, based on the current selection.
             */
            subfields?: {
              /**
               * Value of the field to be filtered.
               */
              if: string;
              /**
               * Label of the subfilter.
               */
              label: string;
              /**
               * Path to the field to be filtered.
               */
              path: string;
            }[];
          }[];
        }
      | {
          /**
           * Label of the filter.
           */
          label: string;
          /**
           * Type of the filter.
           */
          type: "mesh";
          /**
           * Path to the field to be filtered.
           */
          path: string;
        }
    )[];
    /**
     * Settings for the study list table.
     */
    table: {
      /**
       * Number of items per page.
       */
      items_per_page: number;
      /**
       * List of columns to be displayed.
       */
      columns: {
        /**
         * Label of the column.
         */
        label: string;
        /**
         * Path to the field to be displayed.
         */
        path: string;
        /**
         * Whether the column should be a link to the study detail view.
         */
        is_link?: boolean;
        /**
         * Whether the cell contents for this column should be able to wrap or not.
         */
        is_nowrap?: boolean;
        /**
         * Name of the component to be used to render the cell content for this column.
         */
        component?: string;
        [k: string]: unknown;
      }[];
      [k: string]: unknown;
    };
    [k: string]: unknown;
  };
  /**
   * Settings for the study detail view.
   */
  detail: {
    /**
     * Settings for the page metadata.
     */
    meta: {
      /**
       * Path to the field to be used as the page title.
       */
      title_path: string;
      [k: string]: unknown;
    };
    /**
     * Settings for the page head. This is mostly for RDFa support.
     */
    head?: {
      /**
       * Attributes to be added to the html tag.
       */
      htmlAttrs?: {
        /**
         * This interface was referenced by `undefined`'s JSON-Schema definition
         * via the `patternProperty` "^.*$".
         */
        [k: string]: string;
      };
      /**
       * Attributes to be added to the body tag.
       */
      bodyAttrs?: {
        /**
         * This interface was referenced by `undefined`'s JSON-Schema definition
         * via the `patternProperty` "^.*$".
         */
        [k: string]: string;
      };
      [k: string]: unknown;
    };
    /**
     * Settings for the page heading.
     */
    heading: {
      /**
       * Path to the field to be used as the page heading.
       */
      path: string;
      /**
       * RDFa settings for the page heading.
       */
      rdfa?: {
        /**
         * RDFa property type of the page heading.
         */
        property: string;
        /**
         * Path to be used for the RDFa content attribute of the page heading.
         */
        content?: string;
        [k: string]: unknown;
      };
      [k: string]: unknown;
    };
    /**
     * List of elements to be displayed at the top of the page.
     */
    top: {
      /**
       * Label of the element.
       */
      label: string;
      /**
       * Path to the field to be displayed.
       */
      path: string;
      /**
       * Path to the field to be used as the href attribute of the element. If this is set and the path is not empty, the element will be rendered as a link.
       */
      href?: string;
      /**
       * RDFa settings for this element.
       */
      rdfa?: {
        /**
         * RDFa property type of this element.
         */
        property: string;
        /**
         * Path to be used for the RDFa content attribute of this element.
         */
        content?: string;
        [k: string]: unknown;
      };
      /**
       * Name of the component to be used to render this element.
       */
      component?: string;
      [k: string]: unknown;
    }[];
    /**
     * List of panels to be displayed.
     */
    panels: {
      /**
       * Label of the panel.
       */
      label: string;
      /**
       * List of fields to be displayed in the panel.
       */
      fields: {
        /**
         * Label of the field.
         */
        label: string;
        /**
         * Path to the field to be displayed.
         */
        path: string;
        /**
         * Whether the field is a list or not.
         */
        is_list?: boolean;
        /**
         * Type of the field. Emails and URLs will be rendered as a link.
         */
        type: "string" | "email" | "url";
        /**
         * RDFa settings for this element.
         */
        rdfa?: {
          /**
           * RDFa property type of this element.
           */
          property: string;
          /**
           * Path to be used for the RDFa content attribute of this element.
           */
          content?: string;
          [k: string]: unknown;
        };
        [k: string]: unknown;
      }[];
      [k: string]: unknown;
    }[];
    [k: string]: unknown;
  };
  [k: string]: unknown;
}
